<template>
    <div>

        <div v-if="!rows">
            <div class="d-flex justify-content-center">
                <div class="text-center text-success my-2">
                    <b-spinner class="align-middle"></b-spinner>
                    <strong class="mx-2" >Carregando...</strong>
                </div>
            </div>
        </div>
        
        <div v-else>

            <b-pagination v-model="currentPage" pills align="center" :per-page="perPage" :total-rows="rows"></b-pagination>

            <p class="mt-3">Total de Serviços : {{rows}} | Pagina: {{ currentPage }}</p>

            <b-table striped hover small :fields="fields" :per-page="perPage" :current-page="currentPage" :items="items" responsive="sm" >
                <template #cell(envio)="data">
                    <b-badge v-if="data.value == 'false'" variant="danger">Pendente</b-badge> 
                    <b-badge v-else variant="success">{{data.value}}</b-badge>
                </template>

                <template #cell(codRastreio)="data">
                    <b-badge v-if="data.value == 'null'" variant="danger">Pendente</b-badge>
                    <b-badge v-else variant="success">{{data.value}}</b-badge>
                </template>

                <template #cell(dataInstalacao)="data">
                    <b-badge v-if="data.value == 'null'" variant="danger">Pendente</b-badge>
                    <b-badge v-else variant="success">{{data.value}}</b-badge>
                </template>

                <template #cell(conclusao)="data">
                    <b-badge v-if="data.value == 'null'" variant="danger">Pendente</b-badge>
                    <b-badge v-else variant="success">{{data.value}}</b-badge>
                </template>

                <template #cell(id)="data">
                    <b-badge @click="attServico(data.value)" variant="primary">Atualizar</b-badge>
                </template>


            </b-table>

            <div>

                <b-modal id="modalServico" title="Atualizar Status do Serviço" hide-header-close no-close-on-backdrop  no-close-on-esc hide-footer>
                    
                        <p> Nome: <strong>{{userServico.name}}</strong></p>

                        <b-form-checkbox class="mb-2" id="checkbox-1" v-model="userServico.envio" name="checkbox-1" value="Enviado" unchecked-value="false" switch>
                            Status de envio: <strong><span v-if="userServico.envio == 'false'">Pendente</span> <span v-else>Enviado</span></strong>
                        </b-form-checkbox>

                        <div v-if="userServico.envio != 'false'">
                            <label for="cod">Cod. Rastreio</label>
                            <input type="text" id="cod" class="form-control input mb-3" v-model="userServico.codRastreio">
                        </div>

                        <div v-if="userServico.envio != 'false' && userServico.codRastreio != 'null' ">
                            <label for="data">Data de Inicio da Instalação</label>
                            <input type="date" id="data" class="form-control input mb-3" v-model="userServico.dataInstalacao" >
                        </div>

                        <b-form-checkbox v-if="userServico.envio != 'false' && userServico.codRastreio != 'null' && userServico.dataInstalacao != 'null'" class="mb-2" id="checkbox-2" v-model="userServico.iniInstalacao" name="checkbox-1" value="Iniciou" unchecked-value="null" switch>
                            Status de Inicio da Instalação: <strong><span v-if="userServico.iniInstalacao == 'null'">Pendente</span> <span v-else>Iniciou</span></strong>
                        </b-form-checkbox>

                        <b-form-checkbox v-if="userServico.envio != 'false' && userServico.codRastreio != 'null' && userServico.dataInstalacao != 'null' && userServico.iniInstalacao != 'null'" class="mb-2" id="checkbox-3" v-model="userServico.conclusao" name="checkbox-1" value="Concluído" unchecked-value="null" switch>
                                Status de conclusao: <strong><span v-if="userServico.conclusao == 'false'">Pendente</span> <span v-else>Concluido</span></strong>
                        </b-form-checkbox>

                        <div class="mt-4">
                            <button class="btn btn-success" @click="sendServico"  type="submit" > Atualizar </button>
                            <button class="btn btn-danger" @click="hideModal"> Cancelar </button>
                        </div>
                    
                </b-modal>

                <b-modal id="modalStatus" :header-bg-variant="alert.bg" centered  :header-text-variant="alert.color" header-class='border-0 ' body-class='d-none' :title="alert.msg" hide-body  hide-footer>
                </b-modal>
            </div>

        </div>

    </div>
</template>

<script>
import axios from 'axios'
export default {
  name: 'Login',
  data(){
    return{
        perPage: 10,
        currentPage: 1,
        items: [],
        users: [],
        fields: [
          { key: 'etiqueta', label: 'Etiqueta' },
          { key: 'name', label: 'Cliente' },
          { key: 'envio', label: 'Envio' },
          { key: 'codRastreio', label: 'Cod.Rastreio' },
          { key: 'dataInstalacao', label: 'Inicio da Instalação' },
          { key: 'conclusao', label: 'Conclusao' },
          { key: 'id', label: 'Atualizar' },
        ],

        ////////////////////////
        
        userServico:{},
        userServicoBackup: {},

        alert: {
            bg: 'success',
            color: 'white',
            msg: 'Sucesso ao Cadastrar',
        },
        ///////////////////////////////////
        form:{
            name: null
        }
    }
  },
  computed: {
    rows() {
        return this.items.length
    }
  },
  methods:{
    getUser(){
      const _vn = this

      axios.get('https://7re2usa707.execute-api.us-east-1.amazonaws.com/production/user')
      .then(function (response) {
        // console.log(response.data)
        _vn.users = response.data
        _vn.getServico()
      })
      .catch(function (error) {
        console.log(error);
      });
    },
    getServico(){
      const _vn = this

      axios.get('https://7re2usa707.execute-api.us-east-1.amazonaws.com/production/servico')
      .then(function (response) {
        // console.log(response.data)
         response.data.map(item => {
             _vn.users.map(it => {
                it.id == item.idUser  ?
                    _vn.items.push({
                        id             : item.id,
                        idUser         : item.idUser,
                        etiqueta       : item.etiqueta,
                        name           : it.name,
                        email          : it.email,
                        phone          : it.phone,
                        cpf            : it.cpf,
                        envio          : item.envio,
                        codRastreio    : item.codRastreio,
                        dataInstalacao : item.dataInstalacao,
                        iniInstalacao  : item.iniInstalacao,
                        conclusao      : item.conclusao,
                        timestamp      : item.timestamp
                    })
                : 
                    null
             })
         })

        // console.log(_vn.items)
      })
      .catch(function (error) {
        console.log(error);
      });
    },
    attServico(id_user){
        this.items.map(item => {
            if(item.id == id_user){ 
                this.userServico = item
                this.userServicoBackup = item
            }
        })
        this.$bvModal.show("modalServico")

    },
    sendServico(e){
        e.preventDefault()
        const _vn = this
        let cod = ''
        let dataIn = ''
        !_vn.userServico.codRastreio || _vn.userServico.codRastreio == 'null' ? cod = 'null' : cod = _vn.userServico.codRastreio
        !_vn.userServico.dataInstalacao || _vn.userServico.dataInstalacao == 'null' ? dataIn = 'null' : dataIn =  _vn.userServico.dataInstalacao
        let data = {
            id              : _vn.userServico.id,
            idUser          : _vn.userServico.idUser,
            etiqueta         : _vn.userServico.etiqueta,
            envio           : _vn.userServico.envio,
            codRastreio     : cod,
            dataInstalacao : dataIn,
            iniInstalacao  : _vn.userServico.iniInstalacao,
            conclusao      : _vn.userServico.conclusao
        }
        // console.log(data)
        if( _vn.userServico.id){
            axios.put('https://7re2usa707.execute-api.us-east-1.amazonaws.com/production/servico', data)
            .then(function (response) {
                // console.log(response)
                if(response.data.statusCode == 200){
                     _vn.hideModal()
                    _vn.$bvModal.show("modalStatus")
                    _vn.alert = {
                        bg: 'success',
                        color: 'white',
                        msg: 'Serviço cadastrado com sucesso :)',
                    }
                } else {
                    _vn.hideModal()
                      _vn.$bvModal.show("modalStatus")
                    _vn.alert = {
                        bg: 'danger',
                        color: 'white',
                        msg: 'Erro ao salvar. tente mais tarde :/',
                    }

                }
            })
            .catch(function (error) {
                console.log(error);
            });
            
        } else {
            _vn.hideModal()
            _vn.$bvModal.show("modalStatus")
            _vn.alert = {
                bg: 'danger',
                color: 'white',
                msg: 'Erro ao salvar. tente mais tarde :/',
            }

        }
       
    },
    hideModal(){
        this.items = []
        this.getUser()
        this.$bvModal.hide("modalServico")
    }
  },
  mounted(){
    this.getUser()
  }
  
}
</script>

<style>
@media(max-width: 767px){
    table.table th, table.table td  {
         font-size: 12px;
    }
}
</style>